

#include <ddraw.h>
#include "../vjeffect.h"

#define	__NO_STDAFX_

#define STRICT
#define D3D_OVERLOADS
#include "../d3dim/D3DMath.h"
#include "../d3dim/D3DUtil.h"

#define	M_PI	(3.1415926535f)

//--------------------------------------------------------------------------
// NX`
//--------------------------------------------------------------------------
// NX͊{I [Copy/Mix/Modify/Generate]+([3D])+[ŗL̖O] œꂵĂD
//  Copy : In x 1  , Out x 1 (Rs[)
//  Mix  : In x 2+ , Out x 1 (Qȏ̃\[XɃRs[)
//  Modify :       , Out x 1 (o͐ω)
//  Generate :     , Out x 1 (摜𐶐)

//  

// Release() : ~CVJCopy()OQƂȂ,ɑ̂Lq (ėǂł)
// MessageProc() : VJM_??? bZ[W󂯎֐łDfBXpb`ĂD

class CVJCopy3DTunnel : public CVJEffecter
{
public:
	CVJCopy3DTunnel();
	~CVJCopy3DTunnel();

	void Release();
	int MessageProc(int,DWORD,DWORD);
	VJOBJINFO* GetInfo();

	int Init();
	int Effect(VJEFFECTINFO*);

private:
	int colorMode;

	D3DVECTOR pos;		// ʒu
	D3DVECTOR dpos;		// ړ
	D3DMATRIX rot;		// ]matrix
	D3DMATRIX drot;		// ]ψmatrix

};

CVJEffecter* GetVJCopy3DTunnel(){return new CVJCopy3DTunnel();}

VJOBJINFO VJOBJCopy3DTunnel=
{
	sizeof(VJOBJINFO),
	VJ_EFFECT_COPY|VJ_EFFECT_DIRECTDRAW4|VJ_EFFECT_DIRECT3D,
	"Copy3DTunnel",
	1,
	1,
	3+2+1,	// rot(xyz),pos(x,y),scale
	NULL,
	&GetVJCopy3DTunnel
};

VJOBJINFO* CVJCopy3DTunnel::GetInfo(){return &VJOBJCopy3DTunnel;}

CVJCopy3DTunnel::CVJCopy3DTunnel()
{
}

CVJCopy3DTunnel::~CVJCopy3DTunnel()
{
}

void CVJCopy3DTunnel::Release()
{

}

int CVJCopy3DTunnel::MessageProc(int msg,DWORD wParam,DWORD lParam)
{

	if(msg==VJM_INIT)
		return Init(); 

	if(msg==VJM_EFFECT)
		return Effect( (VJEFFECTINFO*)wParam );
}

#define	MAX_T1	128	
#define	MAX_T2	32
#define	CIRCLE_R	(0.5f)

#define NUM_VERTICES (MAX_T1*(MAX_T2+1))
#define NUM_INDICES  ((MAX_T1-1)*MAX_T2*2*3)
static D3DVERTEX     pVertices[NUM_VERTICES];
static WORD          pIndices[NUM_INDICES];


static HRESULT CreateObj( D3DVERTEX* pVertices, WORD* pIndices )
{
    // Define the normals for the cube
    D3DVECTOR n0( 0.0f, 0.0f,-1.0f );


	int i,j,k;
	int n=0;

	D3DVECTOR center( 0.0f ,  0.0f , -0.0f );

	// _̐
	for(i=0;i<MAX_T1;i++)
	{
		D3DMATRIX matRotate,rot;
		D3DUtil_SetMoveMatrix( matRotate, 0,0,0.3f*(i-MAX_T1/2) );
	    D3DUtil_SetRotateYMatrix( rot, 2*M_PI*(i-MAX_T1/2)/MAX_T1 );
	    D3DMath_MatrixMultiply( matRotate,rot, matRotate);

		for(j=0;j<MAX_T2+1;j++)
		{
			D3DVECTOR circle=center + D3DVECTOR( CIRCLE_R*cos(2*M_PI*j/MAX_T2) , CIRCLE_R*sin(2*M_PI*j/MAX_T2),0 );

			D3DVECTOR vector;
			D3DVECTOR grid=D3DVECTOR( cos(2*M_PI*j/MAX_T2) , sin(2*M_PI*j/MAX_T2),0 );
			D3DMath_VectorMatrixMultiply( vector , circle,matRotate);
			D3DMath_VectorMatrixMultiply( grid , grid,matRotate);
			grid=Normalize(grid);
			pVertices[n+j]= D3DVERTEX( vector ,grid , 2.0f*j/(float)MAX_T2 , 0.1f*i);

			if( (i<MAX_T1) && (j<MAX_T2) )
			{
					*pIndices++=n+  j+0;
					*pIndices++=n+  j+0  +(MAX_T2+1);
					*pIndices++=n+  j+1  +(MAX_T2+1);

					*pIndices++=n+  j+0             ;
					*pIndices++=n+  j+1  +(MAX_T2+1);
					*pIndices++=n+  j+1;
			}
		}
		n+=j;
	}

    return S_OK;
}

int CVJCopy3DTunnel::Init()
{
    CreateObj( pVertices, pIndices );

	return 0;
}




int CVJCopy3DTunnel::Effect(VJEFFECTINFO *pInfo)
{
	if(pInfo->cbSize<sizeof(VJEFFECTINFO)) return -1;

	if(pInfo->nInChannel!=1 || pInfo->nOutChannel!=1 || pInfo->nParam!=6) return -1;

	IDirectDrawSurface4 *pDDSi,*pDDSo;
	IDirect3DTexture2 *pDT;
	LPDIRECT3DDEVICE3 pd3dDevice;
	pDDSo=(IDirectDrawSurface4*)pInfo->pOutChannel[0];
	pDT=(IDirect3DTexture2*)pInfo->pInChannel [0];
	pd3dDevice=(LPDIRECT3DDEVICE3)pInfo->pOutChannel[2];

	HRESULT hr;

	float fRotX=pInfo->pParam[0].data*0.01f;
	float fRotY=pInfo->pParam[1].data*0.01f;
	float fRotZ=pInfo->pParam[2].data*0.01f;

	float fMoveX=0;
	float fMoveY=0;
	float fMoveZ=0;

	if( (int)pInfo->pParam[3].type!=-1)
		fMoveX=pInfo->pParam[3].data*0.01f;
	if( (int)pInfo->pParam[4].type!=-1)
		fMoveY=-pInfo->pParam[4].data*0.01f;
	if( (int)pInfo->pParam[5].type!=-1)
	{
		fMoveZ=pInfo->pParam[5].data*0.01f;
		fMoveZ=M_PI*(sin(fMoveZ)+1.0f);
	}

	
	float scale;

		scale=4*4.0f;

	int i,j,n;

	// viewportɖ肪邩
	hr=pd3dDevice->SetRenderTarget( pDDSo, 0 );
    
    hr=pd3dDevice->SetTexture( 0, pDT );
	//pd3dDevice->SetRenderState(D3DRENDERSTATE_CULLMODE, D3DCULL_NONE);
	pd3dDevice->SetRenderState(D3DRENDERSTATE_CULLMODE, D3DCULL_CCW);
	//pd3dDevice->SetRenderState(D3DRENDERSTATE_TRANSLUCENTSORTINDEPENDENT,1);

	// Rotate the cube's world matrix
    D3DMATRIX matScale, matWorld , matRotate,matMove;
	D3DMATRIX matRotateX,matRotateY,matRotateZ,tmp;
    D3DUtil_SetScaleMatrix( matScale, scale,scale,scale );
    D3DUtil_SetRotateXMatrix( matRotateX, fRotX );
    D3DUtil_SetRotateYMatrix( matRotateY, fRotY );
    D3DUtil_SetRotateZMatrix( matRotateZ, fRotZ );
	D3DMath_MatrixMultiply( matRotate , matRotateX, matRotateY);
	D3DMath_MatrixMultiply( matRotate , matRotate , matRotateZ);
	fMoveZ+=-15.0f;
	D3DUtil_SetMoveMatrix( matMove,fMoveX,fMoveY,fMoveZ);
    D3DMath_MatrixMultiply( tmp, matRotate, matScale );
    D3DMath_MatrixMultiply( matWorld, matMove ,tmp);
    hr=pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matWorld );

#if 1
	//}bsO @߃eNX`ʒuXV
	n=0;
	for(i=0;i<MAX_T1;i++)
	{
		D3DMATRIX matRotateZ;
	    D3DUtil_SetRotateZMatrix( matRotateZ, 2*M_PI*i/MAX_T1 );
		for(j=0;j<MAX_T2+1;j++)
		{
			D3DVECTOR grid=D3DVECTOR( cos(2*M_PI*j/MAX_T2) , 0 , sin(2*M_PI*j/MAX_T2) );
			D3DMath_VectorMatrixMultiply( grid , grid,matRotateZ);
			D3DMath_VectorMatrixMultiply( grid , grid,matRotate);
			grid=Normalize(grid);
			//pVertices[n].tu = fRotZ*8.0f +grid.x;
			pVertices[n].tv = 0.1f*i+fRotZ*3.0f;
			//pVertices[n].tv = grid.y;
			n++;
		}
	}
#endif

    // Begin the scene
    if( FAILED( pd3dDevice->BeginScene() ) )
        return 0; // Don't return a "fatal" error

    // Draw the cube
    hr=pd3dDevice->DrawIndexedPrimitive( D3DPT_TRIANGLELIST, D3DFVF_VERTEX,
                                      pVertices, NUM_VERTICES,
                                      pIndices,  NUM_INDICES, 0 );

    // End the scene.
    pd3dDevice->EndScene();

	return 0;
}



	